#pragma once
#include <vector>
#include <memory>
#include "SDL2/SDL.h"
#include "Vector2D.h"
#include "TextureLoader.h"
#include "SoundLoader.h"
#include "Timer.h"



class Unit
{
public:
	enum class Team {
		folder,
		file
	} team;


	Unit(SDL_Renderer* renderer, Vector2D setPos, Team setTeam);
	void update(float dT, std::vector<std::shared_ptr<Unit>>& listUnits);
	void draw(SDL_Renderer* renderer);
	bool isAlive();
	std::weak_ptr<Unit> findEnemyUnit(std::vector<std::shared_ptr<Unit>>& listUnits);
	Team getTeam();


private:
	void removeHealth(int amount);


	Vector2D pos;
	static const float speed;

	Timer timerJustHurt, timerWeapon;

	const int healthMax = 4;
	int healthCurrent = healthMax;

	std::weak_ptr<Unit> unitTarget;

	SDL_Texture* texture = nullptr;
	Mix_Chunk* mix_ChunkAttack = nullptr;
	Mix_Chunk* mix_ChunkDie = nullptr;
};